SystemOrganization addCategory: #'Magritte-Critics'!

RBBlockLintRule subclass: #MAMagritteLintRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

MAMagritteLintRule subclass: #MAAccessorDefinitionRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MAAccessorDefinitionRule methodsFor: 'running' stamp: 'lr 1/5/2010 16:50'!
checkMethod: aContext
	self withDescription: aContext do: [ :description |
		| accessor instance |
		accessor := description accessor.
		instance := aContext selectedClass theNonMetaClass basicNew.
		((accessor isKindOf: MAAccessor)
			and: [ (accessor canRead: instance)
			and: [ (description isReadonly or: [ accessor canWrite: instance ]) ] ])
				ifFalse: [ result addClass: aContext selectedClass selector: aContext selector ] ]! !

!MAAccessorDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:06'!
name
	^ 'Accessor Definition'! !

!MAAccessorDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:38'!
rationale
	^ 'The accessors should be able to read and write the domain model.'! !

MAMagritteLintRule subclass: #MAContainerDefinitionRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MAContainerDefinitionRule methodsFor: 'running' stamp: 'lr 1/5/2010 16:37'!
checkClass: aContext
	self withContainer: aContext validate: false do: [ :description |
		(description isDescription and: [ description isContainer ])
			ifFalse: [ result addClass: aContext selectedClass theNonMetaClass; addClass: aContext selectedClass theMetaClass ] ]! !

!MAContainerDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:06'!
name
	^ 'Container Definition'! !

!MAContainerDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:11'!
rationale
	^ 'The method #description should always return a valid container description.'! !

!MAContainerDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:12'!
resultClass
	^ ClassEnvironment! !

MAMagritteLintRule subclass: #MADescriptionDefinitionRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MADescriptionDefinitionRule methodsFor: 'running' stamp: 'lr 1/5/2010 16:25'!
checkMethod: aContext
	self withDescription: aContext validate: false do: [ :description |
		(description isDescription and: [ description isContainer not ])
			ifFalse: [ result addClass: aContext selectedClass selector: aContext selector ] ]! !

!MADescriptionDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:06'!
name
	^ 'Description Definition'! !

!MADescriptionDefinitionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:24'!
rationale
	^ 'The #description methods should always return a valid description.'! !

MAMagritteLintRule subclass: #MADescriptionNamingRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MADescriptionNamingRule methodsFor: 'running' stamp: 'lr 1/5/2010 17:14'!
checkMethod: aContext
	self withDescription: aContext do: [ :description |
		(description accessor isKindOf: MASelectorAccessor) ifTrue: [
			('description' , description accessor readSelector asString capitalized = aContext selector asString)
				ifFalse: [ result addClass: aContext selectedClass selector: aContext selector ] ] ]! !

!MADescriptionNamingRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:09'!
name
	^ 'Description Naming'! !

!MADescriptionNamingRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:09'!
rationale
	^ 'The #description definitions should realte to the accessor they describe.'! !

!MAMagritteLintRule class methodsFor: 'testing' stamp: 'lr 1/5/2010 15:51'!
isVisible
	^ self name ~= #MAMagritteLintRule! !

!MAMagritteLintRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:27'!
builder
	^ MADescriptionBuilder default! !

!MAMagritteLintRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 16:10'!
group
	^ 'Magritte'! !

!MAMagritteLintRule methodsFor: 'utilities' stamp: 'lr 1/5/2010 16:22'!
withContainer: aContext do: aBlock
	^ self withContainer: aContext validate: true do: aBlock! !

!MAMagritteLintRule methodsFor: 'utilities' stamp: 'lr 1/5/2010 16:36'!
withContainer: aContext validate: aBoolean do: aBlock
	| description |
	(aContext selectedClass isMeta)
		ifFalse: [ ^ nil ].
	(aContext selectedClass canUnderstand: #description)
		ifFalse: [ ^ nil ].
	description := [ aContext selectedClass theNonMetaClass perform: #description ]
		on: Error
		do: [ :err | ^ nil ].
	aBoolean ifTrue: [ 
		(description isDescription and: [ description isContainer ])
			ifFalse: [ ^ nil ] ].
	^ aBlock value: description! !

!MAMagritteLintRule methodsFor: 'utilities' stamp: 'lr 1/5/2010 16:25'!
withDescription: aContext do: aBlock
	^ self withDescription: aContext validate: true do: aBlock! !

!MAMagritteLintRule methodsFor: 'utilities' stamp: 'lr 1/5/2010 16:32'!
withDescription: aContext validate: aBoolean do: aBlock
	| description |
	(aContext selectedClass isMeta)
		ifFalse: [ ^ nil ].
	(aContext selector isDescriptionSelector)
		ifFalse: [ ^ nil ].
	(aContext selector = self builder containerSelector)
		ifTrue: [ ^ nil ].
	description := [ aContext selectedClass theNonMetaClass perform: aContext selector ]
		on: Error
		do: [ :err | ^ nil ].
	description isNil
		ifTrue: [ ^ nil ].
	(aBoolean and: [ description isDescription not ])
		ifTrue: [ ^ nil ].
	^ aBlock value: description! !

MAMagritteLintRule subclass: #MAMetaDescriptionRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MAMetaDescriptionRule methodsFor: 'running' stamp: 'lr 1/5/2010 17:26'!
checkMethod: aContext
	self withDescription: aContext do: [ :description |
		[ [ description description validate: description ]
			on: MAValidationError
			do: [ :err | result addClass: aContext selectedClass selector: aContext selector into: err displayString ] ]
			on: Error
			do: [ :err | ] ]! !

!MAMetaDescriptionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:06'!
name
	^ 'Meta Description'! !

!MAMetaDescriptionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:38'!
rationale
	^ 'Descriptions should validate against the meta-model of Magritte.'! !

!MAMetaDescriptionRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:02'!
resultClass
	^ MultiEnvironment! !

MAMagritteLintRule subclass: #MAPriorityContainerRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Critics'!

!MAPriorityContainerRule methodsFor: 'running' stamp: 'lr 1/5/2010 17:25'!
checkClass: aContext
	self withContainer: aContext do: [ :description |
		| priorities |
		priorities := (description children
			collect: [ :each | each priority ])
			reject: [ :each | MADescription defaultPriority = each ].
		priorities asBag valuesAndCounts keysAndValuesDo: [ :value :count |
			count > 1 ifTrue: [
				result addSearchString: value asString.
				result addClass: aContext selectedClass theNonMetaClass; addClass: aContext selectedClass theMetaClass ] ] ]! !

!MAPriorityContainerRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:16'!
name
	^ 'Priority Container'! !

!MAPriorityContainerRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:16'!
rationale
	^ 'The priorities in a container should be different from each other.'! !

!MAPriorityContainerRule methodsFor: 'accessing' stamp: 'lr 1/5/2010 17:15'!
resultClass
	^ ClassEnvironment! !
